//+------------------------------------------------------------------+
//|                                                DayRangeXrust.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       TimeOpen=13;
extern int       TimeClose=23;
extern int       DayMax=30;
extern int       SlProc=23;
extern int       TpProc=23;
extern int       Delta=0;
extern double    Lots=0.1;
extern bool      Rew=false;
extern bool      SecOp=false;
extern bool      CloseOr=false;
//---------------------------------
bool UseSound,trade;
int magic=97879,BarsLeft;
static int prevtime = 0 ;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {int tf;
//----
  if(Period()>60){trade=false;Comment("NO_RIGHT_TIMEFRAME");return(0);}
   else
    {
     trade=true;
     if(Period()==1){BarsLeft=TimeOpen*60;}
     if(Period()==5){BarsLeft=TimeOpen*12;}
     if(Period()==15){BarsLeft=TimeOpen*4;}
     if(Period()==30){BarsLeft=TimeOpen*2;}
     if(Period()==60){BarsLeft=TimeOpen*1;}
     }   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  if(!trade)return(0);
  int sl,tp,ticket;
//-------------------------------------------------------------------------------------
  if (Time[0] == prevtime) return(0);// ,    
   prevtime = Time[0];  
  if(DayOfWeek()==5){TimeClose=20;}else{TimeClose=TimeClose;}//  -   20,00     
//-------------------------------------------------------------------------------------+
  if(Hour()==TimeOpen)
   {
    sl=((Todayrange()/100)*SlProc);
    tp=((Todayrange()/100)*TpProc);
    if(Todayrange()>=DayRange(DayMax)+((YesterdayRange()/100)*Delta))
     {
      if(Trand()=="Ap"&&OrdersTotal()<1){open(true,sl,tp,Lots);}
      if(Trand()=="Dn"&&OrdersTotal()<1){open(false,sl,tp,Lots);}
      }
   //------------------------
   Comment(
           "DayMax",+DayMax+"\n"+
           "DayRange"+DayRange(DayMax)+"\n"+
           "YesterdayRange"+YesterdayRange()+"\n"+
           "Todayrange"+Todayrange()+"\n"+Trand()
            );
   //------------------------   
   }
//-------------------------------------------------------------------------------------+   
  if(CloseOr&&Hour()>=TimeClose&&OrdersTotal()>0)
    {OrderSelect(0,SELECT_BY_POS,MODE_TRADES);ticket=OrderTicket();del(ticket);}
//-----------------------
   return(0);
  }
//+---------------    -----------------------+
int DayRange(int NymbOfDay)
 {
 double Range=0;
 if(iClose(Symbol(),1440,NymbOfDay+1)==0){return(0);}
  else   
   {for(int n=1;n<NymbOfDay+1;n++){Range+=(iHigh(Symbol(),1440,n)-iLow(Symbol(),1440,n));}}
 Range=(Range/NymbOfDay)/Point;//      
 return(Range);
 }
//--------------    -----------------------+   
int YesterdayRange()
 {
 double yesterdayRange=(iHigh(Symbol(),1440,1)-iLow(Symbol(),1440,1))/Point;
 return(yesterdayRange);
 }
//-------------    -----------------------+  
int Todayrange()
 {
 double todayrange=(iHigh(Symbol(),1440,0)-iLow(Symbol(),1440,0))/Point; 
 return(todayrange);
 }
//---------------    -----------------------+ 
string Trand(int shift=0)
 {
 string trand;
 if(iHighest(Symbol(),0,MODE_HIGH,BarsLeft,shift)>iLowest(Symbol(),0,MODE_LOW,BarsLeft,shift)){trand="Dn";}
 if(iHighest(Symbol(),0,MODE_HIGH,BarsLeft,shift)<iLowest(Symbol(),0,MODE_LOW,BarsLeft,shift)){trand="Ap";}
 return(trand);
 }
  
 
//+-----------------  ---------------------------+
int del(int ticket)
   {
    
    int err;
        GetLastError();// 
        OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
        string symbol = OrderSymbol();
        
        if(OrderType()==OP_BUY)
         {
          RefreshRates();
           double prise = MarketInfo(symbol,MODE_BID);
            OrderClose(ticket,OrderLots(),prise,3,Green);
             err = GetLastError();
             }
        if(OrderType()==OP_SELL)
         {
          RefreshRates();
           prise = MarketInfo(symbol,MODE_ASK);
            OrderClose(ticket,OrderLots(),prise,3,Green);
             err = GetLastError();
             }
        
        if (err == 0&&UseSound){PlaySound("expert.wav");} if (err != 0) {PlaySound("timeout.wav");Print(err);} 
        while (!IsTradeAllowed()){ Sleep(5000);}//      5  
    return(err);     
    } 
//--------  -------------------------------------+
int open(bool tip,int Sl,int Tp,double lots)
{//tip = false => OP_BUY ; tip = true => OP_SELL;
   GetLastError();
   int err;
   double lastprise,prise,sl,tp; //   
   int ticket;
   int slip =(MarketInfo(Symbol(),MODE_SPREAD))*Point;//  = 
   
//------   
   while (!IsTradeAllowed()){ Sleep(5000);}//      5 
   if (tip == false)
    {
     prise = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits);
     if(Sl!=0){sl = NormalizeDouble((MarketInfo(Symbol(),MODE_BID)-(Sl*Point)),Digits);}else{sl=0;}
     if(Tp!=0){tp = NormalizeDouble((MarketInfo(Symbol(),MODE_ASK)+(Tp*Point)),Digits);}else{tp=0;}
     for(int i=0;i<5;i++) 
      {
       RefreshRates();//  
        ticket = OrderSend(Symbol(), OP_BUY,lots ,prise, slip,sl,tp,NULL,magic,0, Blue);
         if (ticket < 0)
          {
           if(UseSound){PlaySound("timeout.wav");}
            Print("  !",prise,"  ",sl,"  ",tp,"      BUY!");
             }
              else
               {
                break;
                 }
                  }
                   }
  if(tip==true)
   {
    prise = NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits);
    if(Sl!=0){sl = NormalizeDouble((MarketInfo(Symbol(),MODE_ASK)+(Sl*Point)),Digits);}else{sl=0;}
    if(Tp!=0){tp = NormalizeDouble((MarketInfo(Symbol(),MODE_BID)-(Tp*Point)),Digits);}else{tp=0;}    
    for( i=0;i<5;i++) 
     {
      RefreshRates();//  
       ticket = OrderSend(Symbol(), OP_SELL, lots ,prise, slip,sl,tp,NULL,magic,0, Red);
        if (ticket < 0)
         {
          if(UseSound){PlaySound("timeout.wav");}
           Print("  !",prise,"  ",sl,"  ",tp,"      SELL!");
            }
             else
              {
               break;
                }
                 }
                  }

return(ticket); 
 }   
 
      
      
    

